set size 0.63,0.60
set style data lines
set term pslatex solid color norotate

set lmargin 4
set rmargin 1
set bmargin 1
set tmargin 1

unset key

set pointsize 0.5

xmin=0.0; xmax=0.2; dx = xmax-xmin; set xtics 0,dx/4
set xra [xmin:xmax]

ymin=0.75; ymax=1.0; dy = ymax-ymin; set ytics 0.8,0.1
set yra [ymin:ymax]

set label 1 '$p$' at 0.175, ymin-0.015
set label 2 '$\displaystyle \frac{\Lambda(p,0)}{\Lambda(0,0)}$' at -0.035, 0.95

set label 11 '0.001' at 0.160,0.85
set label 12 '0.064' at 0.160,0.77
set label 13 '0.128' at 0.125,0.76
set label 14 '0.160' at 0.084,0.79
set label 15 '0.200' at 0.060,0.82
set label 16 '0.220' at 0.035,0.855
set label 17 '0.240' at 0.009,0.90

dir = 'Data/'
set out 'Src_7.tex'
plot dir.'L_p_e=0_kappa=0.001'  w lp lt 1 pt 7, \
     dir.'L_p_e=0_kappa=0.064'  w lp lt 1 pt 7, \
     dir.'L_p_e=0_kappa=0.128'  w lp lt 1 pt 7, \
     dir.'L_p_e=0_kappa=0.160'  w lp lt 1 pt 7, \
     dir.'L_p_e=0_kappa=0.200'  w lp lt 1 pt 7, \
     dir.'L_p_e=0_kappa=0.220'  w lp lt 1 pt 7, \
     dir.'L_p_e=0_kappa=0.240'  w lp lt 1 pt 7

exit
