pure subroutine make_F(z,F)
  use blocks
  implicit none
  real*8, intent(in)  :: z(1:N)
  real*8, intent(out) :: F(1:N)

  integer*4           :: i, j, sgn
  real*8              :: x, Ss, Sd, sum

  INTERFACE

     pure subroutine make_S(x,Ss,Sd)
       use blocks
       real*8, intent(in)  :: x
       real*8, intent(out) :: Ss, Sd
     end subroutine make_S

  END INTERFACE

  i_loop: do i=1,N

     sum = rz

     j_loop: do j=1,N
        if(j .eq. i) cycle j_loop
        sgn = (-1)**(j-i)
        if(j .gt. i) sgn=-sgn
        x = dabs(z(i) - z(j))
        call make_S(x,Ss,Sd)
        sum = sum + sgn*(Ss/(x*x) + pi*Sd) 
     end do j_loop

     F(i) = sum*kappa ! kappa = q*q / k * h^3

  end do i_loop
        
  return
end subroutine make_F
