pure subroutine make_Fa(p, e, za, zb, Fa)
  use blocks
  implicit none
  real*8, intent(in)  :: p, e 
  real*8, intent(in)  :: za(1:N), zb(1:N)
  real*8, intent(out) :: Fa(1:N)

  integer*4           :: i, j, sgn
  real*8              :: xaa, xab, zab, Ss, Sd, sr
  real*8              :: sum_em, sum_el

  INTERFACE

     pure subroutine make_Ss(x,Ss)
       use blocks
       real*8, intent(in)  :: x
       real*8, intent(out) :: Ss
     end subroutine make_Ss

     pure subroutine make_Sd(x,Sd)
       use blocks
       real*8, intent(in)  :: x
       real*8, intent(out) :: Sd
     end subroutine make_Sd

  END INTERFACE

  i_loop:  do i=1,N

     sum_em = rz
     sum_el = rz

     j_loop: do j=1,N
        if(j .eq. i) cycle j_loop
        sgn = (-1)**(j-i)
        if(j .gt. i) sgn=-sgn
        xaa = dabs(za(i) - za(j))
        call make_Ss(xaa, Ss)
        xab = dabs(za(i) - zb(j))
        call make_Sd(xab, Sd)
        sum_em = sum_em + sgn*(Ss/(xaa*xaa) + pi*Sd) 
     end do j_loop

     zab = za(i) - zb(i)
     xab = dabs(zab)
     if(xab .gt. tiny) then
        call make_Sd(xab, Sd)
        sr = dsqrt(ru + xab*xab)
        if(zab .gt. rz) then
           sum_em = sum_em - pi   * (ru-Sd)
           sum_el = sum_el - four * (sr-ru)*xab / sr
        else
           sum_em = sum_em + pi   * (ru-Sd)
           sum_el = sum_el + four * (sr-ru)*xab / sr
        end if
     end if

     sum_em = sum_em + sa(i)*e
         
     Fa(i)  = kappa*sum_em + sum_el ! kappa = q*q / k * h^3

  end do i_loop

  Fa(1) = Fa(1) + p
  Fa(N) = Fa(N) - p

  return
end subroutine make_Fa
