pure subroutine make_Fa_i(i, p, e, za, zb, Fa)
  use blocks
  implicit none
  integer*4, intent(in)  :: i
  real*8,    intent(in)  :: p, e 
  real*8,    intent(in)  :: za(1:N), zb(1:N)
  real*8,    intent(out) :: Fa
  
  real*8                 :: xaa, xab, zab, Ss, Sd, sr
  real*8                 :: sum_em, sum_el, diff
  integer*4              :: j, sgn
  logical*4              :: flag_1, flag_2

  INTERFACE

     pure subroutine make_Ss(x,Ss)
       use blocks
       real*8, intent(in)  :: x
       real*8, intent(out) :: Ss
     end subroutine make_Ss

     pure subroutine make_Sd(x,Sd)
       use blocks
       real*8, intent(in)  :: x
       real*8, intent(out) :: Sd
     end subroutine make_Sd

  END INTERFACE

  sum_em = rz
  sum_el = rz

  if(i .gt. 1) then
  flag_1 = .false.; flag_2 = .false.
  j_loop_1: do j=i-1,1,-1
     sgn = (-1)**(j-i)
     xaa = dabs(za(i) - za(j))
     if(xaa .gt. xc) flag_1 = .true.
     xab = dabs(za(i) - zb(j))
     if(xab .gt. xc) flag_2 = .true.
     if(flag_1 .and. flag_2) exit j_loop_1
     call make_Ss(xaa, Ss)
     call make_Sd(xab, Sd)
     sum_em = sum_em + sgn*(Ss/(xaa*xaa) + pi*Sd) 
  end do j_loop_1
  end if

  if(i .lt. N) then
  flag_1 = .false.; flag_2 = .false.
  j_loop_2: do j=i+1,N,1
     sgn = -(-1)**(j-i)
     xaa = dabs(za(i) - za(j))
     if(xaa .gt. xc) flag_1 = .true.
     xab = dabs(za(i) - zb(j))
     if(xab .gt. xc) flag_2 = .true.
     if(flag_1 .and. flag_2) exit j_loop_2
     call make_Ss(xaa, Ss)
     call make_Sd(xab, Sd)
     sum_em = sum_em + sgn*(Ss/(xaa*xaa) + pi*Sd) 
  end do j_loop_2
  end if

  zab = za(i) - zb(i)
  xab = dabs(zab)
  if(xab .gt. tiny) then
     call make_Sd(xab, Sd)
     diff = ru - A0*xab - Sd
     sr = dsqrt(ru + xab*xab)
     if(zab .gt. rz) then
        sum_em = sum_em - pi   * diff
        sum_el = sum_el - four * (sr-ru)*xab / sr
     else
        sum_em = sum_em + pi   * diff
        sum_el = sum_el + four * (sr-ru)*xab / sr
     end if
  end if

  sum_em = sum_em + sa(i)*e
         
  Fa  = kappa*sum_em + sum_el ! kappa = q*q / k * h^3
      
  if(i .eq. 1) Fa = Fa + p
  if(i .eq. N) Fa = Fa - p

  return
end subroutine make_Fa_i
