pure subroutine make_Fb_i(i, p, e, za, zb, Fb)
  use blocks
  implicit none
  integer*4, intent(in)  :: i
  real*8,    intent(in)  :: p, e 
  real*8,    intent(in)  :: za(1:N), zb(1:N)
  real*8,    intent(out) :: Fb

  real*8                 :: xba, xbb, zba, Ss, Sd, sr
  real*8                 :: sum_em, sum_el, diff
  integer*4              :: j, sgn
  logical*4              :: flag_1, flag_2

  INTERFACE

     pure subroutine make_Ss(x,Ss)
       use blocks
       real*8, intent(in)  :: x
       real*8, intent(out) :: Ss
     end subroutine make_Ss

     pure subroutine make_Sd(x,Sd)
       use blocks
       real*8, intent(in)  :: x
       real*8, intent(out) :: Sd
     end subroutine make_Sd

  END INTERFACE

  sum_em = rz
  sum_el = rz

  if(i .gt. 1) then
  flag_1 = .false.; flag_2 = .false.
  j_loop_1: do j=i-1,1,-1
     sgn = (-1)**(j-i)
     xbb = dabs(zb(i) - zb(j))
     if(xbb .gt. xc) flag_1 = .true.
     xba = dabs(zb(i) - za(j))
     if(xba .gt. xc) flag_2 = .true.
     if(flag_1 .and. flag_2) exit j_loop_1
     call make_Ss(xbb, Ss)
     call make_Sd(xba, Sd)
     sum_em = sum_em + sgn*(Ss/(xbb*xbb) + pi*Sd) 
  end do j_loop_1
  end if

  if(i .lt. N) then
  flag_1 = .false.; flag_2 = .false.
  j_loop_2: do j=i+1,N,1
     sgn = -(-1)**(j-i)
     xbb = dabs(zb(i) - zb(j))
     if(xbb .gt. xc) flag_1 = .true.
     xba = dabs(zb(i) - za(j))
     if(xba .gt. xc) flag_2 = .true.
     if(flag_1 .and. flag_2) exit j_loop_2
     call make_Ss(xbb, Ss)
     call make_Sd(xba, Sd)
     sum_em = sum_em + sgn*(Ss/(xbb*xbb) + pi*Sd) 
  end do j_loop_2
  end if

  zba = zb(i) - za(i)
  xba = dabs(zba)
  if(xba .gt. tiny) then
     call make_Sd(xba, Sd)
     diff = ru - A0*xba - Sd
     sr = dsqrt(ru + xba*xba)
     if(zba .gt. rz) then
        sum_em = sum_em - pi   * diff
        sum_el = sum_el - four * (sr-ru)*xba / sr
     else
        sum_em = sum_em + pi   * diff
        sum_el = sum_el + four * (sr-ru)*xba / sr
     end if
  end if

  sum_em = sum_em + sb(i)*e
         
  Fb = kappa*sum_em + sum_el ! kappa = q*q / k * h^3

  if(i .eq. 1) Fb = Fb + p
  if(i .eq. N) Fb = Fb - p

  return
end subroutine make_Fb_i
